<template>
  <div
    v-if="type !== 'edit'"
    id="map"
    :class="{ small: type !== 'public' }"
  ></div>
  <div v-else class="map-popap">
    <div class="map-popap__top">
      <div class="map-popap__label">{{ $t('settings.location') }}</div>
      <div id="geocoder"></div>
      <div class="map-popap__close" @click="$emit('closeMap')" v-wave>
        <svg-icon name="close" />
      </div>
    </div>
    <div class="map-popap__container">
      <div id="map"></div>
      <Button @click="createGeo">Обновить</Button>
    </div>
  </div>
</template>

<script lang="ts">
import {
  defineComponent,
  computed,
  onMounted,
  ref
} from '@nuxtjs/composition-api'
import { useGeoReverseQuery } from '~/sdk/hooks'
import { omit } from 'lodash'
import useGenerateUUID from '@/hooks/generate-uuid'
import Button from '@/components/ui/Button.vue'
export default defineComponent<{
  data: any
  type: string
  onCreate: any
}>({
  name: 'PrivatePage',
  props: ['data', 'type', 'onCreate'],
  components: { Button },
  setup(props, { root }) {
    const marker = ref(props.data?.geo?.coordinates || props.data || [0, 0])
    const { result: getGeo } = useGeoReverseQuery(
      computed(() => ({
        lat: marker.value.lat || 0,
        lng: marker.value.lng || 0,
        lang: root.$i18n.locale
      }))
    )

    onMounted(() => {
      setTimeout(createMap, 50)
    })
    const createMap = () => {
      const mapboxgl = require('mapbox-gl')
      require('mapbox-gl/dist/mapbox-gl.css')

      const MapboxGeocoder = require('@mapbox/mapbox-gl-geocoder')
      require('@mapbox/mapbox-gl-geocoder/dist/mapbox-gl-geocoder.css')

      mapboxgl.accessToken =
        'pk.eyJ1IjoiYWxleGtoYXJlY2giLCJhIjoiY2tibnNqc3EyMXZxdjMwcGptcGFjZ3pidCJ9.gGDpAP5xsODsXr2kI6yfUg'
      const map = new mapboxgl.Map({
        container: 'map',
        style: 'mapbox://styles/alexkharech/ckdj217qt152z1itlob2njbl4?v2',
        center: [marker.value[1], marker.value[0]],
        zoom: 11
      })

      map.resize()

      if (props.type !== 'edit') {
        // new mapboxgl.Marker()
        //   .setLngLat([marker.value[1], marker.value[0]])
        //   .addTo(map)
        map.on('load', function () {
          map.addSource('point', {
            type: 'geojson',
            data: {
              type: 'FeatureCollection',
              features: [
                {
                  type: 'Feature',
                  geometry: {
                    type: 'Point',
                    coordinates: [marker.value[1], marker.value[0]]
                  }
                }
              ]
            }
          })
          // Add a layer showing the places.
          map.addLayer({
            id: 'point',
            type: 'circle',
            source: 'point',
            paint: {
              'circle-radius': 10,
              'circle-color': '#0065ff'
            }
          })
        })
      } else {
        const geocoder = new MapboxGeocoder({
          accessToken: mapboxgl.accessToken,
          mapboxgl: mapboxgl,
          language: root.$i18n.locale,
          types: 'country,region,place,postcode,locality,neighborhood,address',
          marker: {
            color: '#00ffb3'
          },
          placeholder: getGeo?.value
            ? [
                getGeo.value.geo_reverse?.[0].city,
                getGeo.value.geo_reverse?.[0].country
              ]
                .filter(e => !!e)
                .join(', ')
            : root.$t('map_input')
        })

        // geocoder.onAdd(map)

        geocoder.on('result', (e: any) => {
          marker_touch.remove()
          map.setCenter(e.result.center)
          marker_touch = new mapboxgl.Marker({
            color: '#00ffb3',
            draggable: true
          })
            .setLngLat(e.result.center)
            .addTo(map)
          marker_touch.on('dragend', onDragEnd)
          let lngLat = marker_touch.getLngLat()
          marker.value = { lat: lngLat.lat, lng: lngLat.lng }
        })
        geocoder.addTo('#geocoder')

        let marker_touch = new mapboxgl.Marker({
          color: '#0065ff',
          draggable: true
        })
          .setLngLat([marker.value[1], marker.value[0]])
          .addTo(map)
        marker_touch.on('dragend', onDragEnd)

        let lngLat = marker_touch.getLngLat()
        marker.value = { lat: lngLat.lat, lng: lngLat.lng }

        function onDragEnd() {
          let lngLat = marker_touch.getLngLat()
          marker.value = { lat: lngLat.lat, lng: lngLat.lng }
        }
      }
    }

    const createGeo = () => {
      props.onCreate({
        id: useGenerateUUID(),
        location_name: [
          getGeo.value.geo_reverse?.[0].city,
          getGeo.value.geo_reverse?.[0].country
        ]
          .filter(e => !!e)
          .join(', '),
        geo: omit(getGeo.value.geo_reverse?.[0], ['__typename']),
        coordinates: [marker.value.lat, marker.value.lng]
      })
    }

    return { createGeo, getGeo }
  }
})
</script>

<style lang="scss" scoped>
#map {
  height: 450px;
  border-radius: 2px;
  overflow: hidden;
  margin-left: -30px;
  margin-right: -30px;
  margin-bottom: -30px;
  @media (min-width: 991.98px) {
    height: 700px;
    margin: 0px;
  }
  &.small {
    height: 450px;
  }
}
.map-popap {
  position: fixed;
  left: 0px;
  right: 0px;
  top: 0px;
  bottom: 0px;
  padding: 10px;
  background: #131624;
  z-index: 999;
  display: flex;
  flex-direction: column;
  &__close {
    position: absolute;
    right: 20px;
    top: 50%;
    transform: translateY(-50%);
    width: 60px;
    height: 60px;
    background: #252d45;
    border-radius: 50px;
    z-index: 999;
    display: flex;
    align-items: center;
    justify-content: center;
    box-shadow: -1px 3px 37px rgb(0 0 0 / 15%);
    cursor: pointer;
    svg {
      width: 15px;
      height: 15px;
      fill: #00ffb3;
    }
  }
  &__top {
    background-color: #22283a;
    box-shadow: -1px 3px 37px rgb(0 0 0 / 15%);
    padding: 10px 25px 0 25px;
    position: relative;
  }
  &__container {
    flex: 1;
  }
  &__label {
    font-size: 24px;
    line-height: 30px;
    font-weight: 500;
    letter-spacing: 0px;
    color: #00ffb3;
    margin: 0 0 10px 0;
    padding: 0px;
  }
  ::v-deep {
    .mapboxgl-ctrl-geocoder--pin-right {
      display: none !important;
    }
    .mapboxgl-ctrl-geocoder {
      &.mapboxgl-ctrl {
        margin-left: -25px;
        margin-right: -25px;
        width: auto;
        max-width: initial;
        background: 0;
        box-shadow: none;
        border-radius: 0px;
        > svg {
          display: none;
        }
        > input {
          background: 0;
          box-shadow: none;
          border-radius: 0px;
          border: 0;
          border-bottom: 2px solid #495271;
          height: 50px;
          padding: 0 25px 15px 25px;
          color: #fff;
          font-weight: 500;
          font-size: 24px;
          transition: 125ms all;
          &::placeholder {
            color: #fff;
          }
          &:focus {
            border-color: #00ffb3;
          }
        }
      }
      .suggestions {
        margin: 15px;
        width: auto;
        left: 0px;
        right: 0px;
        background: #22273a;
        font-size: 16px;
        line-height: 20px;
        > li {
          > a {
            color: #fff;
            padding: 10px 15px;
            &:hover {
              background-color: rgba(#2e344c, 0.4);
            }
          }
        }
        > .active {
          > a {
            background-color: #2e344c;
            color: #fff;
            &:hover {
              background-color: #2e344c;
            }
          }
        }
      }
      &--suggestion-address {
        opacity: 0.5;
      }
    }
  }
  #map {
    width: 100%;
    height: 100%;
  }
  .mapboxgl-ctrl-geocoder {
    min-width: 100%;
  }
  button {
    position: absolute;
    left: 30px;
    bottom: 30px;
    width: auto;
    min-height: auto;
    z-index: 999;
  }
}
</style>
